#! /usr/local/bin/php
<?php

$url = "http://localhost/gh/rail/simrail.php";


function	putlog($s) {
	print $s."\n";
}


class	rail {
	var	$number;
	var	$lockcount = 0;
	function	rail($number = "00") {
		$this->number = $number;
	}
	function	drive($speed = 0) {
		global	$url;
		
		if ($speed >= 0)
			$command = substr("ABCDEF", min($speed, 5), 1);
		else
			$command = substr("abcdef", min(-$speed, 5), 1);
		file_get_contents($url."?".$this->number."=".$command);
	}
	function	sense() {
		global	$url;
		
		return file_get_contents($url."?".$this->number."=S") + 0;
	}
	function	lock($mode = 1) {
#		printf("rail(%s)->lock(%d) lockcount(%d)\n", $this->number, $mode, $this->lockcount);
		switch ($mode) {
			default:
				die("lock({$mode})");
			case	0:
				if (($this->lockcount--) <= 0)
					die("unlock failed.");
				return;
			case	1:
				if ($this->lockcount > 0)
					return -1;	/* failed. */
				$this->lockcount++;
				return 0;
			case	-1:
				$this->lockcount = 0;
				return;
		}
	}
}

class	revrail extends rail {
	function	drive($speed = 0) {
		parent::drive(-$speed);
	}
}


class	point {
	var	$number, $number2;
	var	$fork = -1;
	var	$lockcount = 0;
	function	point($number = null, $number2 = null) {
		$this->number = $number;
		$this->number2 = $number2;
	}
	function	fork($fork = 0) {	# private
		global	$url;
		
		if ($fork == $this->fork)
			return;		# not change
		
		$this->fork = $fork;
		if ($this->number !== null)
			file_get_contents($url."?".$this->number."=".(($fork)? "P" : "p"));
		if ($this->number2 !== null)
			file_get_contents($url."?".$this->number2."=".(($fork)? "P" : "p"));
	}
	function	lock($mode = 0) {
		if ($mode == 0) {
			if ($this->lockcount-- <= 0)
				die("unlock failed.");
			return 0;
		}
		$mode = ($mode > 0)? 1 : 0;
		if (($this->lockcount == 0)&&($this->fork != $mode))
			$this->fork($mode);
		if ($this->fork != $mode)
			return -1;
		$this->lockcount++;
		return 0;
	}
}


#     r9       r8       r7       r6       r5
# |--------|--------|--------|--------|--------|
#              ><p0            p1><
# |--------|--------|--------|--------|--------|
#     r0       r1       r2       r3       r4

$r0 =& new revrail("07");
$r1 =& new revrail("08");
$p0 =& new point("04", "09");
$r2 =& new revrail("0a");
$p1 =& new point("02", "0b");
$r3 =& new revrail("0c");
$r4 =& new revrail("0d");

$r5 =& new revrail("00");
$r6 =& new revrail("01");
$r7 =& new revrail("03");
$r8 =& new revrail("05");
$r9 =& new revrail("06");

switch (@$argv[1]) {
	case	"p0":
		$p0->drive(0);
		$p1->drive(0);
		die("p0");
	case	"p1":
		$p0->drive(1);
		$p1->drive(0);
		die("p1");
	case	"p2":
		$p0->drive(0);
		$p1->drive(1);
		die("p2");
	case	"p3":
		$p0->drive(1);
		$p1->drive(1);
		die("p3");
	case	"r0":
		$r0->drive(-3);
		$r1->drive(-3);
		$r2->drive(-3);
		$r3->drive(-3);
		$r4->drive(-3);
		die("r0");
	case	"r1":
		$r5->drive(3);
		$r6->drive(3);
		$r7->drive(3);
		$r8->drive(3);
		$r9->drive(3);
		die("r1");
}


class	train	{
	var	$mode = -1;
	function	train($start = 0) {
		global	$r0, $r1, $r2, $r3, $r4, $r5, $r6, $r7, $r8, $r9;
		global	$p0, $p1;
		
		switch ($start) {
			default:
				die("start:".$start);

#     r9       r8       r7       r6       r5
# |aaaaaaaa|--------|cccccccc|--------|00000000|
#              ><p0            p1><
# |88888888|--------|44444444|--------|22222222|
#     r0       r1       r2       r3       r4
			case	0:
				$p =& $r5;
				break;
			case	2:
				$p =& $r4;
				break;
			case	4:
				$p =& $r2;
				break;
			case	8:
				$p =& $r0;
				break;
			case	10:
				$p =& $r9;
				break;
			case	12:
				$p =& $r7;
				break;
		}
		if ($p->sense() == 0) {
			putlog("not found:".$start);
			return;			# mode = -1;
		}
		putlog("found:".$start);
		$p->lock(1);
		$this->mode = $start;
	}
	function	step() {
		global	$r0, $r1, $r2, $r3, $r4, $r5, $r6, $r7, $r8, $r9;
		global	$p0, $p1;
		
		switch 	($this->mode) {
			default:
				die("mode:".$this->mode);
			case	-1:
				return;

#     r9       r8       r7       r6       r5
# |--------|--------|--------|-----<<<|<<<<<<<<|
#              ><p0            p1><
# |--------|--------|----<<<<|<<<-----|--------|
#     r0       r1       r2       r3       r4
			case	0:
				if ($r6->lock(1) >= 0) {
					if ($r3->lock(1) >= 0) {
						if ($r2->lock(1) >= 0) {
							if ($p1->lock(1) >= 0) {
								$r2->drive(0);
								$r3->drive(-3);
								$r6->drive(-4);
								$r5->drive(-4);
								$this->mode++;
								return;
							}
							$r2->lock(0);
						}
						$r3->lock(0);
					}
					$r6->lock(0);
				}
				return;
			case	1:
				if ($r2->sense() == 0)
					return;
				$p1->lock(0);
				$r5->drive(0);
				$r5->lock(0);
				$r6->drive(0);
				$r6->lock(0);
				$r3->drive(0);
				$r3->lock(0);
				$this->mode = 4;
				return;

#     r9       r8       r7       r6       r5
# |--------|--------|--------|--------|--------|
#              ><p0            p1><
# |--------|--------|----<<<<|<<<<<<<<|<<<<<<<<|
#     r0       r1       r2       r3       r4
			case	2:
				if ($r3->lock(1) >= 0) {
					if ($r2->lock(1) >= 0) {
						if ($p1->lock(-1) >= 0) {
							$r2->drive(0);
							$r3->drive(-3);
							$r4->drive(-4);
							$this->mode++;
							return;
						}
						$r2->lock(0);
					}
					$r3->lock(0);
				}
				return;
			case	3:
				if ($r2->sense() == 0)
					return;
				$p1->lock(0);
				$r4->drive(0);
				$r4->lock(0);
				$r3->drive(0);
				$r3->lock(0);
				$this->mode = 4;
				return;

#     r9       r8       r7       r6       r5
# |--------|--------|--------|--------|--------|
#              ><p0            p1><
# |----<<<<|<<<<<<<<|<<<<<<<<|--------|--------|
#     r0       r1       r2       r3       r4
			case	4:
				if ($r0->lock(1) >= 0) {
					if ($r1->lock(1) >= 0) {
						if ($p0->lock(-1) >= 0) {
							$r0->drive(0);
							$r1->drive(-3);
							$r2->drive(-4);
							$this->mode = 1004;
							return;
						}
						$r1->lock(0);
					}
					$r0->lock(0);
#     r9       r8       r7       r6       r5
# |----<<<<|<<<-----|--------|--------|--------|
#              ><p0            p1><
# |--------|-----<<<|<<<<<<<<|--------|--------|
#     r0       r1       r2       r3       r4
				} else if ($r9->lock(1) >= 0) {
					if ($r1->lock(1) >= 0) {
						if ($r8->lock(1) >= 0) {
							if ($p0->lock(1) >= 0) {
								$r9->drive(0);
								$r8->drive(-3);
								$r1->drive(-4);
								$r2->drive(-4);
								$this->mode = 6;
								return;
							}
							$r8->lock(0);
						}
						$r1->lock(0);
					}
					$r9->lock(0);
				}
				return;
			case	1004:
				if (($r1->sense())||($r0->sense())){
					$r2->drive(0);
					$r2->lock(0);
					$this->mode = 5;
				}
				return;
			case	5:
				if ($r0->sense() == 0)
					return;
				$p0->lock(0);
				$r1->drive(0);
				$r1->lock(0);
				$this->mode = 8;
				return;

			case	6:
				if (($r1->sense())||($r9->sense())){
					$r2->drive(0);
					$r2->lock(0);
					$this->mode++;
				}
				return;
			case	7:
				if ($r9->sense() == 0)
					return;
				$p0->lock(0);
				$r1->drive(0);
				$r1->lock(0);
				$r8->drive(0);
				$r8->lock(0);
				$this->mode = 10;
				return;

#     r9       r8       r7       r6       r5
# |--------|----->>>|>>>>----|--------|--------|
#              ><p0            p1><
# |>>>>>>>>|>>>-----|--------|--------|--------|
#     r0       r1       r2       r3       r4
			case	8:
				if ($r1->lock(1) >= 0) {
					if ($r8->lock(1) >= 0) {
						if ($r7->lock(1) >= 0) {
							if ($p0->lock(1) >= 0) {
								$r7->drive(0);
								$r8->drive(3);
								$r1->drive(4);
								$r0->drive(4);
								$this->mode++;
								return;
							}
							$r7->lock(0);
						}
						$r8->lock(0);
					}
					$r1->lock(0);
				}
				return;
			case	9:
				if ($r7->sense() == 0)
					return;
				$p0->lock(0);
				$r0->drive(0);
				$r0->lock(0);
				$r1->drive(0);
				$r1->lock(0);
				$r8->drive(0);
				$r8->lock(0);
				$this->mode = 12;
				return;

#     r9       r8       r7       r6       r5
# |>>>>>>>>|>>>>>>>>|>>>>----|--------|--------|
#              ><p0            p1><
# |--------|--------|--------|--------|--------|
#     r0       r1       r2       r3       r4
			case	10:
				if ($r8->lock(1) >= 0) {
					if ($r7->lock(1) >= 0) {
						if ($p0->lock(-1) >= 0) {
							$r7->drive(0);
							$r8->drive(3);
							$r9->drive(4);
							$this->mode++;
							return;
						}
						$r7->lock(0);
					}
					$r8->lock(0);
				}
				return;
			case	11:
				if ($r7->sense() == 0)
					return;
				$p0->lock(0);
				$r9->drive(0);
				$r9->lock(0);
				$r8->drive(0);
				$r8->lock(0);
				$this->mode = 12;
				return;

#     r9       r8       r7       r6       r5
# |--------|--------|>>>>>>>>|>>>>>>>>|>>>>>>>>|
#              ><p0            p1><
# |--------|--------|--------|--------|--------|
#     r0       r1       r2       r3       r4
			case	12:
				if ($r5->lock(1) >= 0) {
					if ($r6->lock(1) >= 0) {
						if ($p1->lock(-1) >= 0) {
							$r5->drive(0);
							$r6->drive(3);
							$r7->drive(4);
							$this->mode = 1013;
							return;
						}
						$r6->lock(0);
					}
					$r5->lock(0);
#     r9       r8       r7       r6       r5
# |--------|--------|>>>>>>>>|>>>-----|--------|
#              ><p0            p1><
# |--------|--------|--------|----->>>|>>>>----|
#     r0       r1       r2       r3       r4
				} else if ($r4->lock(1) >= 0) {
					if ($r6->lock(1) >= 0) {
						if ($r3->lock(1) >= 0) {
							if ($p1->lock(1) >= 0) {
								$r4->drive(0);
								$r3->drive(3);
								$r6->drive(4);
								$r7->drive(4);
								$this->mode = 14;
								return;
							}
							$r3->lock(0);
						}
						$r6->lock(0);
					}
					$r4->lock(0);
				}
				return;
			case	1013:
				if (($r6->sense())||($r5->sense())) {
					$r7->drive(0);
					$r7->lock(0);
					$this->mode = 13;
				}
				return;
			case	13:
				if ($r5->sense() == 0)
					return;
				$p1->lock(0);
				$r6->drive(0);
				$r6->lock(0);
				$this->mode = 0;
				return;

			case	14:
				if (($r6->sense())||($r4->sense())) {
					$r7->drive(0);
					$r7->lock(0);
					$this->mode++;
				}
				return;
			case	15:
				if ($r4->sense() == 0)
					return;
				$p1->lock(0);
				$r6->drive(0);
				$r6->lock(0);
				$r3->drive(0);
				$r3->lock(0);
				$this->mode = 2;
				return;
		}
	}
}


$trainlist = array();
foreach (array(0, 2, 8, 10) as $start)
	$trainlist[] =& new train($start);

for (;;) {
	foreach ($trainlist as $key => $dummy)
		$trainlist[$key]->step();
}


?>
